/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package dialog;

import ihm.Application;
import ihm.FenetrePrincipale;


import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Label;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import cout.Cout;
import cout.CoutMult;
import cout.CoutP1;
import calcul.Matrice;
/**
 * Dialog servant a afficher un cout
 * Utiliser dans menu traitement
 * @author giraudet-e
 *
 */
public class DialogAfficheCout extends JDialog{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Cout cout1;
	
	@SuppressWarnings("unchecked")
	public DialogAfficheCout(Cout c)
	{
		super(FenetrePrincipale.getInstance());
		JPanel pTout;
		cout1=c;
		if(c.estCoutP1())
			pTout = traiteCout1(((CoutP1)(c)).getMatrice());
		else
			pTout = traiteCout1(((CoutMult)(c)).getMatrice());
		
	
		
		
		JScrollPane jsp = new JScrollPane(pTout);
		add(jsp);
		setLocationRelativeTo(getParent());
		setResizable(false);
		setVisible(true);
	}
	
	public JPanel traiteCout1(final Matrice m)
	{

		final int ligne = m.getNbLigne();
		final int colonne = m.getNbColonne();
		JPanel pTout = new JPanel(){
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;
			public Dimension getMinimumSize()
			{
				return dim(m);
			}
			public Dimension getPreferredSize()
			{
				return this.getMinimumSize();
			}
			public Dimension getMaximumSize()
			{
				return this.getMinimumSize();
			}
		};
		JPanel pmatrice = new JPanel();
		pmatrice.setBorder(BorderFactory.createTitledBorder(Application.langue.getProperty("matrice")));
		JPanel pideal = new JPanel();
		setTitle(Application.langue.getProperty("afficheTitreacout"));
		pTout.setBorder(BorderFactory.createTitledBorder(cout1.getNom()));
		
		JLabel tideal = new JLabel(Application.langue.getProperty("tideal"));
		JLabel ideal = new JLabel(cout1.getIdeal().AfficheMatrice());
		pideal.add(tideal);
		JPanel pide = new JPanel();
		pide.add(ideal);
		
		
		pmatrice.setLayout(new GridLayout(colonne,ligne));
		for(int i=0;i<ligne;i++)
		{
			for(int j=0;j<colonne;j++)
			{
				pmatrice.add(new Label(String.valueOf(m.getCase(i,j))));
			}
		}
		
		pTout.setLayout(new BoxLayout(pTout,BoxLayout.Y_AXIS));
		pTout.add(pmatrice);
		pTout.add(pideal);
		pTout.add(pide);

		setSize(300,200);
		return pTout;
	}
	
	
	
	
	
	private Dimension dim(Matrice m)
	{
		int x=0;
		int y=m.getNbLigne()*20+4*25;
		for(int i=0;i<m.getNbLigne();i++)
			for(int j=0;j<m.getNbColonne();j++)
				if(m.getCase(i, j).toString().length()>x)
					x=m.getCase(i, j).toString().length();
		if(x*20>10*12)
			x=x*20;
		else
			x=10*12;
		return new Dimension(x,y);
		
	}
	
}
