/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package dialog;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import graphe.Graphe;
import ihm.Application;
import ihm.FenetrePrincipale;
import ihm.transition.Transition;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import util.JIntField;
import calcul.Matrice;
/**
 * Dialog utilise dans le cas d'ajout d'un cout sur les transitions pour les couts non multiplicatif
 * @author giraudet-docet
 *
 */
public class DialogAjoutCoutTransition extends JDialog {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public DialogAjoutCoutTransition(Graphe g,JButton valider,final Matrice<Integer> cout,Transition t)
	{
		super(FenetrePrincipale.getInstance());
		final int dep = g.listeEtats.indexOf(t.getEtatDepart());
		final int arr = g.listeEtats.indexOf(t.getEtatArrivee());
		JPanel pTout= new JPanel();
		JLabel lbValeur = new JLabel(Application.langue.getProperty("lbValeur"));
		final JIntField iVal= new JIntField(10);
		iVal.setInt(cout.getCase(dep,arr));
		pTout.add(lbValeur);
		pTout.add(iVal);

		
		JPanel pbouton = new JPanel();
		pbouton.add(valider);
		JPanel jp = new JPanel();
		jp.add(pTout);
		jp.add(pbouton);
		add(jp);
		setLocationRelativeTo(FenetrePrincipale.getInstance());
		setSize(200,125);
		setResizable(false);
		setVisible(true);
		valider.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				int i=iVal.getInt();
				cout.setCase(dep,arr,i);
				dispose();
			}
		});
	}
	
	


}
