/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package dialog;

import ihm.Application;
import ihm.FenetrePrincipale;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
/**
 * Classe qui herite de la classe JDialog et qui permet de demander à l'utilisateur
 * s'il veut vraiment quitter
 * @author Docet Giraudet
 *
 */
public class DialogConfirmeQuitter  extends JDialog 
{
	private static final long serialVersionUID = 1L;
	/**
	 * Constructeur qui lance la JDialog au quel on lui donne les deux boutons
	 * La taille de la JDialog est de 200 par 100
	 * @param oui
	 * @param non
	 */
	public DialogConfirmeQuitter(JButton oui, JButton non)
	{
		super(FenetrePrincipale.getInstance());
		JLabel lb = new JLabel(Application.langue.getProperty("quitter")+" ?");
		
		oui.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				dispose();
			}
		});
		non.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				dispose();
			}
		});
		
		JPanel pn = new JPanel();
		pn.add(lb);
		JPanel pn1 = new JPanel();
		pn1.setLayout(new FlowLayout());
		pn1.add(oui);
		pn1.add(non);
		setLayout(new BorderLayout());
		add(pn,BorderLayout.NORTH);
		add(pn1,BorderLayout.SOUTH);
		setSize(200,100);
		setResizable(false);
		setLocationRelativeTo(getParent());
		setVisible(true);
	}

}
