/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package dialog;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import ihm.Application;
import ihm.FenetrePrincipale;
import ihm.dessin.DessinGraphe;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import calcul.RechercheLocale;

import util.JFloatField;
import util.JIntField;

/**
 * Dialog utilise dans le cas ou l'on veut modifier les parametres de la recherche locale
 * @author Giraudet
 *
 */
public class DialogParametreRL extends JDialog{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public DialogParametreRL()
	{
		super(FenetrePrincipale.getInstance());
		setTitle(Application.langue.getProperty("nomTitredprl"));
		JPanel p1 = new JPanel();
		JPanel p2 = new JPanel();
		JPanel p3 = new JPanel();
		JPanel p4 = new JPanel();
		JPanel p5 = new JPanel();
		final JIntField jif1 = new JIntField(6);
		final JFloatField jff2 = new JFloatField(6);
		final JIntField jif3 = new JIntField(6);
		final JIntField jif4 = new JIntField(6);
		final JFloatField jff5 = new JFloatField(6);
		JLabel jl1 = new JLabel(Application.langue.getProperty("rrs"));
		JLabel jl2= new JLabel(Application.langue.getProperty("pas"));
		JLabel jl3 = new JLabel(Application.langue.getProperty("nbi"));
		JLabel jl4= new JLabel(Application.langue.getProperty("tl"));
		JLabel jl5 = new JLabel(Application.langue.getProperty("prec"));
		jif1.setInt(RechercheLocale.getRS());
		jff2.setFloat((float)RechercheLocale.getPas());
		jif3.setInt(RechercheLocale.getNBI());
		jif4.setInt(RechercheLocale.getTL());
		jff5.setFloat(DessinGraphe.EPSILON.floatValue());
		p1.add(jl1);
		p1.add(jif1);
		p2.add(jl2);
		p2.add(jff2);
		p3.add(jl3);
		p3.add(jif3);
		p4.add(jl4);
		p4.add(jif4);
		p5.add(jl5);
		p5.add(jff5);
		JPanel pTout = new JPanel();
		JPanel pBoutons = new JPanel();
		JButton valider = new JButton(Application.langue.getProperty("valider"));
		JButton annuler = new JButton(Application.langue.getProperty("annuler"));
		annuler.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				dispose();
			}
		});
		valider.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				dispose();
				RechercheLocale.setParametre(jif1.getInt(), jff2.getFloat(), jif3.getInt(), jif4.getInt());
				DessinGraphe.setEpsilon(jff5.getFloat());
			}
		});
		pBoutons.add(valider);
		pBoutons.add(annuler);
		JPanel jp = new JPanel();
		jp.setLayout(new GridLayout(5,1));
		jp.add(p1);
		jp.add(p2);
		jp.add(p3);
		jp.add(p4);
		jp.add(p5);
		pTout.add(jp,BorderLayout.CENTER);
		pTout.add(pBoutons,BorderLayout.SOUTH);
		add(pTout);
		setSize(300,300);
		setLocationRelativeTo(FenetrePrincipale.getInstance());
		setVisible(true);
	}

}
