/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package dialog;

import ihm.Application;
import ihm.FenetrePrincipale;
import ihm.dessin.DessinGraphe;

import java.awt.BorderLayout;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import calcul.MethodeResolution;
/**
 * Classe servant a choisir les requetes que l'on veut utiliser pour la recherche locale
 * @author Giraudet
 *
 */
public class DialogRechercheLocale extends Dialog{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private DessinGraphe _dg;
	private ArrayList<Boolean> ab;
	public DialogRechercheLocale(DessinGraphe dg,final JButton jb)
	{
		super(FenetrePrincipale.getInstance());
		_dg=dg;
		JPanel pCheckBox= new JPanel(){
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			public Dimension getMinimumSize()
			{
				return new Dimension(this.getWidth(),this.getHeight());
			}

			@Override
			public Dimension getPreferredSize()
			{
				return getMinimumSize();
			}

			@Override
			public Dimension getMaximumSize()
			{
				return getMinimumSize();
			}
		};
		
		ajoutMethode(pCheckBox);
		pCheckBox.setSize(new Dimension(_dg.methodes.size()*30,_dg.methodes.size()*50));
		JPanel pBouton = new JPanel();
		JButton lancer = new JButton(Application.langue.getProperty("lancer"));
		JButton annuler = new JButton(Application.langue.getProperty("annuler"));
		lancer.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				jb.setEnabled(false);
				ArrayList<MethodeResolution> lmr = new ArrayList<MethodeResolution>();
				for(int i=0;i<ab.size();i++)
					if(ab.get(i))
						lmr.add(_dg.methodes.get(i));
				_dg.RechercheLocale(lmr,jb);
				dispose();
			}
		});
		annuler.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				dispose();
			}
		});
		pBouton.add(lancer);
		pBouton.add(annuler);
		JScrollPane jsp = new JScrollPane(pCheckBox);
		add(jsp,BorderLayout.CENTER);
		add(pBouton,BorderLayout.SOUTH);
		setSize(300,300);
		setResizable(false);
		setLocationRelativeTo(getParent());
		setVisible(true);
		
	}
	
	public void ajoutMethode(JPanel pCheckBox)
	{
		ab= new ArrayList<Boolean>();
		pCheckBox.setLayout(new GridLayout(_dg.methodes.size(),1));
		for(int i=0;i<_dg.methodes.size();i++)
		{
			final int t=i;
			MethodeResolution mr = _dg.methodes.get(i);
			final JCheckBox jcb = new JCheckBox();
			ab.add(false);
			jcb.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e)
				{
					ab.set(t, jcb.isSelected());
				}
			});
			JPanel jp = new JPanel();
			JLabel jl = new JLabel(mr.toString());
			jp.add(jcb);
			jp.add(jl);
			pCheckBox.add(jp);
		}
	}

}
