/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
 */

package dialog;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import ihm.Application;
import ihm.FenetrePrincipale;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import test3D.Test3D2;

import calcul.Matrice;

public class DialogSelectionneVariable extends JDialog{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public DialogSelectionneVariable(final int n,int v1,int v2,int v3,final Matrice<ArrayList<Double>> listefacette,final ArrayList<ArrayList<Double>> ensemblepoints)
	{
		super(FenetrePrincipale.getInstance(),Application.langue.getProperty("nomdsv"));
		if(listefacette!=null)
		{
		final ArrayList<Boolean> l = new ArrayList<Boolean>();
		JPanel jp = new JPanel()
		{
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			public Dimension getMinimumSize()
			{
				return new Dimension(300,90+n*2*45);
			}

			public Dimension getPreferredSize()
			{
				return this.getMinimumSize();
			}

			public Dimension getMaximumSize()
			{
				return this.getMinimumSize();
			}
		};
		JLabel jl = new JLabel(Application.langue.getProperty("labeldsv"));
		jp.setLayout(new BoxLayout(jp,BoxLayout.Y_AXIS));
		JPanel jpl = new JPanel();
		jpl.add(jl,"center");
		jp.add(jpl);
		for(int i=0;i<n;i++)
			for(int j=0;j<n-1;j++)
			{
				final JCheckBox jcb = new JCheckBox();
				final int t = 2*i+j;
				if(t==v1 || t==v2 || t==v3)
					jcb.setSelected(true);
				else
					jcb.setSelected(false);
				jcb.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						l.set(t, jcb.isSelected());
					}
				});
				JLabel jla = new JLabel(i+"->"+j);
				JPanel cadre = new JPanel();
				cadre.add(jcb);
				cadre.add(jla);
				l.add(jcb.isSelected());
				jp.add(cadre);
			}
		JButton valider = new JButton(Application.langue.getProperty("valider"));
		JButton annuler = new JButton(Application.langue.getProperty("annuler"));
		JPanel pBouton = new JPanel();
		valider.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				dispose();
				int cpt=0;
				for(int i=0;i<l.size();i++)
					if(l.get(i))
						cpt++;
				if(cpt!=3)
					new ErreurDialog(Application.langue.getProperty("erreurdsv"));
				Matrice<ArrayList<Double>> lres = new Matrice<ArrayList<Double>>(listefacette.getNbLigne(),listefacette.getNbColonne());
				ArrayList<ArrayList<Double>> lens = new ArrayList<ArrayList<Double>>();
				for(int i=0;i<lres.getNbLigne();i++)
					for(int j=0;j<lres.getNbColonne();j++)
					{
						ArrayList<Double> point = new ArrayList<Double>();
						for(int k=0;k<l.size();k++)
							if(l.get(k))
								point.add(listefacette.getCase(i, j).get(k));
						lres.setCase(i, j, point);
					}
				for(int i=0;i<ensemblepoints.size();i++)
				{
					ArrayList<Double> point = new ArrayList<Double>();
					ArrayList<Double> p = ensemblepoints.get(i);
					for(int j=0;j<p.size();j++)
						if(l.get(j))
							point.add(p.get(j));
					lens.add(point);
				}
				//for(float i=0.5f;i<10;i+=0.5)
					new Test3D2(lres,lens);
			}
		});
		annuler.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				dispose();
			}
		});
		pBouton.add(valider);
		pBouton.add(annuler);
		jp.add(pBouton);
		JScrollPane jsp = new JScrollPane(jp);
		add(jsp);
		setSize(300,300);
		setVisible(true);
		}
	}

}
