/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package ihm;



import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.WindowConstants;


/**
 * Classe qui lance l'application, elle ne contient qu'un main qui crée une instance de la classe FenêtrePrincipale
 * @author Giraudet Docet
 */

public class Application 
{
	public static Properties langue;
	public static Properties config;

	public Application(){}

	public static void main(String[] args) 
	{
		
		final JFrame chooseLangage = new JFrame();
			chooseLangage.addWindowListener(new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					chooseLangage.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
					chooseLangage.dispose();
					 System.exit(0);
				}
			});
		FileInputStream in = null;
		config=new Properties();
			try 
			{
				in = new FileInputStream("config.ini");
				config.load(in);
				in.close();
			} 
			catch (FileNotFoundException e1) 
			{
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			int nblangue = Integer.valueOf(config.getProperty("nblangue"));
		String v[] = new String[nblangue] ;
		for(int i=0;i<nblangue;i++)
			v[i]=config.getProperty("langue"+(i+1));

		final JComboBox jcb = new JComboBox(v);
		JLabel jl=new JLabel("Choose your langage");
		JPanel jp = new JPanel();
		JPanel pBoutons = new JPanel();
		JButton lancer = new JButton("launch");
		JButton annuler = new JButton("cancel");
		pBoutons.add(lancer);
		pBoutons.add(annuler);
		JPanel pLabel = new JPanel();
		jp.add(jcb,BorderLayout.CENTER);
		pLabel.add(jl,BorderLayout.CENTER);
		chooseLangage.add(pLabel,BorderLayout.NORTH);
		chooseLangage.add(jp,BorderLayout.CENTER);
		chooseLangage.add(pBoutons,BorderLayout.SOUTH);
		chooseLangage.setSize(300,200);
		jcb.setEditable(false);
		jcb.setMaximumRowCount(3);
		chooseLangage.setLocationRelativeTo(chooseLangage.getParent());
		chooseLangage.setTitle(FenetrePrincipale.NOM_LOGICIEL);
		chooseLangage.setVisible(true);
		lancer.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{
				chooseLangage.dispose();
				FileInputStream in = null;
				langue=new Properties();
				int i = jcb.getSelectedIndex();
				try 
				{
					in = new FileInputStream(config.getProperty("fichier"+(i+1)));
					langue.load(in);
					in.close();
				} 
				catch (FileNotFoundException e1) 
				{
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (IOException er) {
					// TODO Auto-generated catch block
					er.printStackTrace();
				}
				FenetrePrincipale fen = FenetrePrincipale.getInstance();
				fen.setVisible(true);
			}
		});
		
		annuler.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				chooseLangage.dispose();
			}
		});
	}

}
