/*
Copyright Bourdon Jeremie 
contributors : Giraudet Etienne, Docet Eric

jeremie.bourdon@univ-nantes.fr
eric.docet@etu.univ-nantes.fr
etienne.giraudet@etu.univ-nants.fr

This software is a computer program whose purpose is to do computations
on genetic graphs.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.
*/

package test3D;


import ihm.Application;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;

import javax.media.j3d.Appearance;
import javax.media.j3d.Background;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.LineArray;
import javax.media.j3d.PolygonAttributes;
import javax.media.j3d.Shape3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.TriangleStripArray;
import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.WindowConstants;
import javax.vecmath.Color3f;
import javax.vecmath.Point3d;

import calcul.Matrice;

import com.sun.j3d.utils.behaviors.mouse.MouseRotate;
import com.sun.j3d.utils.behaviors.mouse.MouseTranslate;
import com.sun.j3d.utils.behaviors.mouse.MouseZoom;
import com.sun.j3d.utils.universe.SimpleUniverse;

public class Test3D2 extends JFrame{

	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Matrice<ArrayList<Double>> _l;
	private double _zoom;
	private ArrayList<ArrayList<Double>> points;
	private Point3d centre;
	private double min1,min2,min3;
	private double max1,max2,max3;
	
	
	
	public Test3D2(Matrice<ArrayList<Double>> l,ArrayList<ArrayList<Double>> ens)
	{
		super("3D ");
		_l=l;
		addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
				dispose();
			}
		});
		
		points=ens;
		centre=CalculCentre();
		_zoom=CalculZoom();
	
	    
	    JPanel protate = new JPanel(){
	    	/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			public Dimension getMinimumSize()
			{
				return new Dimension(300,300);
			}
			
			public Dimension getPreferredSize()
			{
				return this.getMinimumSize();
			}
			
			public Dimension getMaximumSize()
			{
				return this.getMinimumSize();
			}
	    };
		protate.setBorder(BorderFactory.createBevelBorder(1));
	    Canvas3D cr = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
	    cr.setBackground(Color.white);
	    protate.setLayout(new BorderLayout());
		protate.add(cr,BorderLayout.CENTER);
		BranchGroup scener = createSceneGraphRotate();
		SimpleUniverse simpleUr = new SimpleUniverse(cr);
	    simpleUr.addBranchGraph(scener);
	    simpleUr.getViewingPlatform().setNominalViewingTransform();
	    JLabel jl = new JLabel(Application.langue.getProperty("label3D")+"v1 ["+min1+";"+max1+"] v2 ["+min2+";"+max2+"] v3 ["+min3+";"+max3+"]");
	    JPanel pla = new JPanel();
	    pla.add(jl);
	    
	    this.setLayout(new BorderLayout());
	   
	    JScrollPane jspr = new JScrollPane(protate);
	   
	    this.add(jspr,BorderLayout.CENTER);
	    this.add(pla,BorderLayout.SOUTH);
		this.setSize(Toolkit.getDefaultToolkit().getScreenSize());
		this.setVisible(true);
		
	}
	

	
	public BranchGroup createSceneGraphRotate()
	{
		BranchGroup objRoot = new BranchGroup();
		Background background = new Background (1,1,1);
		Shape3D s = new Shape3D(createGeometry(),createAppearance());
        TransformGroup objTransform = new TransformGroup();
        objTransform.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        objTransform.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);

        objRoot.addChild(objTransform);
        objTransform.addChild(s);
        objTransform.addChild(createxAxis());
		objTransform.addChild(createyAxis());
		objTransform.addChild(createzAxis());
        MouseRotate myMouseRotate = new MouseRotate();
        myMouseRotate.setTransformGroup(objTransform);
        myMouseRotate.setSchedulingBounds(new BoundingSphere());
        objRoot.addChild(myMouseRotate);

        MouseTranslate myMouseTranslate = new MouseTranslate();
        myMouseTranslate.setTransformGroup(objTransform);
        myMouseTranslate.setSchedulingBounds(new BoundingSphere());
        objRoot.addChild(myMouseTranslate);

        MouseZoom myMouseZoom = new MouseZoom();
        myMouseZoom.setTransformGroup(objTransform);
        myMouseZoom.setSchedulingBounds(new BoundingSphere());
        objRoot.addChild(myMouseZoom);
        objRoot.addChild(background);
        objRoot.compile();

	return objRoot;

		
	}
	
	
	 TriangleStripArray createGeometry(){

	    Color3f blue  = new Color3f(1f, 1f, 1f);

	        int N = _l.getNbLigne()*_l.getNbColonne();
	        int stripCounts[] = {N};
	        TriangleStripArray twistStrip = new TriangleStripArray(N,TriangleStripArray.COORDINATES  | TriangleStripArray.COLOR_3,stripCounts);
	       
	        int cpt=0;
	        for(int i=0;i<_l.getNbLigne();i++)
	        {
	        	for(int j=0;j<_l.getNbColonne();j++)
	        	{
	        		ArrayList<Double> lp=_l.getCase(i, j);
	        		Point3d x = new Point3d((lp.get(0)-centre.x)*_zoom,(lp.get(1)-centre.y)*_zoom,(lp.get(2)-centre.z)*_zoom);
	        		twistStrip.setCoordinate(cpt, x);
	        			twistStrip.setColor(cpt, blue);
	        			cpt++;
	        		
	        	}
	        }
	     
	       return twistStrip;
	 


	    }
	 
	
	
	 public Shape3D createxAxis()
	 {
		 LineArray xAxis= new LineArray(2, LineArray.COORDINATES | LineArray.COLOR_3 );
		 xAxis.setCoordinate(0, new Point3d(1.1f, 0f, 0f));
		 xAxis.setCoordinate(1, new Point3d(-1.1f, 0f, 0f));
		 xAxis.setColor(0, new Color3f(0f,0f,1f));
		 return new Shape3D(xAxis);
	 }
	 
	 public Shape3D createyAxis()
	 {
		 LineArray yAxis= new LineArray(2, LineArray.COORDINATES | LineArray.COLOR_3 );
		 yAxis.setCoordinate(0, new Point3d(0f, 1.1f, 0f));
		 yAxis.setCoordinate(1, new Point3d(0f, -1.1f, 0f));
		 yAxis.setColor(0, new Color3f(1f,0f,0f));
		 return new Shape3D(yAxis);
	 }
	 
	 public Shape3D createzAxis()
	 {
		 LineArray zAxis= new LineArray(2, LineArray.COORDINATES | LineArray.COLOR_3 );
		 zAxis.setCoordinate(0, new Point3d(0f, 0f, 1.1f));
		 zAxis.setCoordinate(1, new Point3d(0f, 0f, -1.1f));
		 zAxis.setColor(0, new Color3f(0f,1f,0f));
		 return new Shape3D(zAxis);
	 }
	 
	 

     Appearance createAppearance(){

    		Appearance app=new Appearance();
    		app.setPolygonAttributes(new PolygonAttributes
    			(PolygonAttributes.POLYGON_LINE
    			,PolygonAttributes.CULL_NONE
    			,0f));
    		return app;

     }
     
    
     
     public Point3d CalculCentre()
     {
    	 Point3d p;
    	 double x=0;
    	 double y=0;
    	 double z=0;
    	 for(int i=0;i<points.size();i++)
    	 {
    		 ArrayList<Double> po = points.get(i); 
    		 x+=po.get(0);
    		 y+=po.get(1);
    		 z+=po.get(2);
    	 }
    	 p=new Point3d(x/points.size(),y/points.size(),z/points.size());
    	 return p;
     }
     
     public double CalculZoom()
     {
    	 double max=Double.NEGATIVE_INFINITY;
    	 min1=Double.POSITIVE_INFINITY;
    	 min2=Double.POSITIVE_INFINITY;
    	 min3=Double.POSITIVE_INFINITY;
    	 max1=Double.NEGATIVE_INFINITY;
    	 max2=Double.NEGATIVE_INFINITY;
    	 max3=Double.NEGATIVE_INFINITY;
    	 
    	 for(int i=0;i<points.size();i++)
    	 {
    		 ArrayList<Double> po = points.get(i);
    		 double x =po.get(0)-centre.x;
        	 double y = po.get(1)-centre.y;
        	 double z = po.get(2)-centre.z;
        	 if(x<0)
        	 {
        		 if(1+x<1+min1)
        			 min1=x;
        	 }
        	else
        	{
        		if(1-x<1-max1)
        			max1=x;
        	}
        	 if(y<0)
        	 {
        		 if(1+y<1+min2)
        			 min2=y;
        	 }
        	else
        	{
        		if(1-y<1-max2)
        			max2=y;
        	}
        	 if(z<0)
        	 {
        		 if(1+z<1+min3)
        			 min3=z;
        	 }
        	else
        	{
        		if(1-z<1-max3)
        			max3=z;
        	}
    	 }
    	if(1+min1<1-max1)
    		 max=Math.abs(min1);
    	 else
    		 max=max1;
    	 if(1+min2<1-max)
    		 max=Math.abs(min2);
    	 if(1-max2<1-max)
    		 max=max2;
    	 if(1+min3<1-max)
    		 max=Math.abs(min3);
    	 if(1-max3<1-max)
    		 max=max3;
    	 min1=min1+centre.x;
    	 min2=min2+centre.y;
    	 min3=min3+centre.y;
    	 max1=max1+centre.x;
    	 max2=max2+centre.y;
    	 max3=max3+centre.z;
    	return 0.9/max;

     }
	
	
}
